<id>
Rules YaBB2
</id>

<version>
1.3
</version>

<mod info>
This mod adds the topic "Rules" to the main menu. You can edit the rules from admin center.

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

AdminIndex.pl
Admin/ModList.pl
Admin/AdminEdit.pl
Admin/AdminSubList.pl
Sources/Subs.pl
Languages/English/Menu.lng
Variables/Menu0.def
Variables/Menu1.def
Variables/Menu2.def
Languages/English/RefControl.lng

3) Load files to your server in ASCII mode.

cgi-bin/yabb2/Languages/English/Rules.lng
cgi-bin/yabb2/Languages/English/rules.txt
cgi-bin/yabb2/Sources/Rules.pl
public_html/yabbfiles/Buttons/English/rules.gif
public_html/yabbfiles/Templates/Forum/default/rules.gif
</mod info>

<author>
Gekko
</author>

<homepage>
gogekko@gmx.net
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$rules_mod = "rules|Edit Rules|Edit Rules|";
push (@boardmod_mods, "$rules_mod");

</add before> 

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$rules_mod = "Rules_YaBB2|Gekko|Adds the topic 'Rules' to the main menu. You can edit the rules from admin center.|1.2|05/05/05";
	push (@installed_mods, "$rules_mod");

</add before>

<edit file>
Admin/AdminEdit.pl
</edit file>

<search for>
LoadLanguage("Register");
</search for>

<add after>
LoadLanguage("Rules");
</add after>

<search for>
	$FORM{'agreement'} =~ s~\n\Z~~;
	fopen(AGREE, ">$langdir/$agreementlanguage/agreement.txt");
	print AGREE $FORM{'agreement'};
	fclose(AGREE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}
</search for>

<add after>
sub ModifyRules {
	&is_admin_or_gmod;
	my($ruleslanguage, $line);
	if($FORM{'ruleslanguage'}) {
$ruleslanguage = $FORM{'ruleslanguage'}
	}
	else { $ruleslanguage = $lang; }
	opendir(LNGDIR,$langdir);
	my @lfilesanddirs = readdir(LNGDIR);
	close(LNGDIR);
	foreach $fld (@lfilesanddirs){
		if(-d "$langdir/$fld" && $fld =~ m^\A[0-9a-zA-Z_\#\%\-\:\+\?\$\&\~\,\@/]+\Z^){
			if ($ruleslanguage eq $fld){$drawnldirs .= qq~<option value="$fld" selected="selected">$fld</option>~;}
			else {$drawnldirs .= qq~<option value="$fld">$fld</option>~;}
		}
	}

	my( $rules, $line );
	fopen(AGREE, "$langdir/$ruleslanguage/rules.txt");
	while( $line = <AGREE> ) {
		$line =~ tr/[\r\n]//d;
		&FromHTML($line);
		$rules .= qq~$line\n~;
	}
	fclose(AGREE);
	$yymain .= qq~

 <div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
   <table width="100%" cellspacing="1" cellpadding="4">
     <tr valign="middle">
       <td align="left" class="titlebg">
<img src="$imagesdir/xx.gif" alt="" border="0" /><b>$rules_txt{'2'}</b>
	   </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2"><br />
		$rules_txt{'3'}<br /><br />
	   </td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2"><br />
	<form action="$adminurl?action=rules" method="post">
	$templs{'8'}
	<select name="ruleslanguage" id="ruleslanguage" size="1">
		$drawnldirs
	</select>
	<input type="submit" value="$admin_txt{'462'}" />
	</form>
	   </td>
     </tr>
     <tr valign="middle">
       <td align="center" class="windowbg2"><br />
	<form action="$adminurl?action=rules2" method="post">
	<input type="hidden" name="ruleslanguage" value="$ruleslanguage" />
	<textarea rows="40" cols="95" name="rules" style="width:95%">$rules</textarea><br /><br />
	   </td>
     </tr>
     <tr valign="middle">
       <td align="center" class="catbg">
		 <input type="submit" value="$admin_txt{'10'} $ruleslanguage" />
	   </td>
     </tr>
	</form>
   </table>
 </div>
~;
	$yytitle = "$rules_txt{'2'}";
	$action_area = "rules";
	&AdminTemplate;
	exit;
}

sub ModifyRules2 {
	&is_admin_or_gmod;
	if($FORM{'ruleslanguage'}) { $ruleslanguage = $FORM{'ruleslanguage'}; }
	else { $ruleslanguage = $lang; }
	$FORM{'rules'} =~ tr/\r//d;
	$FORM{'rules'} =~ s~\A\n~~;
	$FORM{'rules'} =~ s~\n\Z~~;
	fopen(AGREE, ">$langdir/$ruleslanguage/rules.txt");
	print AGREE $FORM{'rules'};
	fclose(AGREE);
	$yySetLocation = qq~$adminurl~;
	&redirectexit;
}
</add after>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'modagreement2',"AdminEdit.pl&ModifyAgreement2",
</search for>

<add after>
'rules',"AdminEdit.pl&ModifyRules",
'rules2',"AdminEdit.pl&ModifyRules2",
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$scripturl?action=help" style="cursor:help;">$img{'help'}</a>~;
</search for>

<replace>
	$yymenu = qq~<a href="$scripturl">$img{'home'}</a>$menusep<a href="$scripturl?action=help" style="cursor:help;">$img{'help'}</a>$menusep<a href="$scripturl?action=rules">$img{'rules'}</a>~;
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'revalidatesession2',"Sessions.pl&SessionReval2",
</search for>

<add after>
'rules',"Rules.pl&Rules",
</add after>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
'105' => "Last Post",
</search for>

<add after>
'106' => "Rules",
</add after>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
'help' => "<img src=\"$imagesdir/help.$imgext\" alt=\"$img_txt{'119'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'119'}</span>",
</search for>

<add after>
'rules' => "<img src=\"$modimgurl/rules/rules.$imgext\" alt=\"$img_txt{'106'}\" border=\"0\" /> <span class=\"imgmenu\">$img_txt{'106'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
'help' => "<span class=\"imgmenu\">$img_txt{'119'}</span>",
</search for>

<add after>
'rules' => "<span class=\"imgmenu\">$img_txt{'106'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
'help' => "<img src=\"$html_root/Buttons/$language/help.$imgext\" alt=\"$img_txt{'119'}\" border=\"0\" />",
</search for>

<add after>
'rules' => "<img src=\"$modimgurl/rules/rules.$imgext\" alt=\"$img_txt{'106'}\" border=\"0\" />",
</add after>

<edit file>
Languages/English/RefControl.lng
</edit file>

<search for>
'revalidatesession2',"Process Admin Session Revalidation",
</search for>

<add after>
'rules' => "Show Rules",
</add after>
